#include "num_to_string.hh"

using namespace std ;

NumToString::NumToString() {
  first20.clear() ;
  first20.reserve(20) ;
  first20.push_back("") ;
  first20.push_back("one") ;
  first20.push_back("two") ;
  first20.push_back("three") ;
  first20.push_back("four") ;
  first20.push_back("five") ;
  first20.push_back("six") ;
  first20.push_back("seven") ;
  first20.push_back("eight") ;
  first20.push_back("nine") ;
  first20.push_back("ten") ;
  first20.push_back("eleven") ;
  first20.push_back("twelve") ;
  first20.push_back("thirteen") ;
  first20.push_back("fourteen") ;
  first20.push_back("fifteen") ;
  first20.push_back("sixteen") ;
  first20.push_back("seventeen") ;
  first20.push_back("eighteen") ;
  first20.push_back("nineteen") ;
    
  tens.clear() ;
  tens.reserve(10) ;
  tens.push_back("zero") ;
  tens.push_back("ten") ;
  tens.push_back("twenty") ;
  tens.push_back("thirty") ;
  tens.push_back("forty") ;
  tens.push_back("fifty") ;
  tens.push_back("sixty") ;
  tens.push_back("seventy") ;
  tens.push_back("eighty") ;
  tens.push_back("ninety") ;
}

NumToString::~NumToString() {
  
}

string
NumToString::to_string_less_than_1000( int num ) const {

  string res = "" ;
  // convert the first two digit
  int tmp = num%100 ;
  if ( tmp < 20 ) {
    res = first20[tmp] ;
  } else {
    res = tens[tmp/10] ;
    if ( (tmp%10) != 0 ) res += "-" + first20[tmp%10] ;
  }
  
  // convert hundreds
  num /= 100 ;
  tmp = num%10 ;
  if ( tmp > 0 ) {
    if ( res.length() > 0 ) res = first20[tmp]+"-hundred-"+res ;
    else                    res = first20[tmp]+"-hundred" ;
  }
  return res ;

}


string
NumToString::to_string( int num ) const {
  string res = to_string_less_than_1000( num ) ;

  // convert thousand
  string res1 = to_string_less_than_1000( num/1000 ) ;
  if ( res1.length() > 0 ) {
    if ( res.length() > 0 ) res = res1+"-thousand-"+res ;
    else                    res = res1+"-thousand" ;
  }

  // convert millions
  res1 = to_string_less_than_1000( num/1000000 ) ;
  if ( res1.length() > 0 ) {
    if ( res.length() > 0 ) res = res1+"-million-"+res ;
    else                    res = res1+"-million" ;
  }

  // convert billion
  res1 = to_string_less_than_1000( num/1000000000 ) ;
  if ( res1.length() > 0 ) {
    if ( res.length() > 0 ) res = res1+"-billion-"+res ;
    else                    res = res1+"-billion" ;
  }

  return res ;
}
